#version 130 // GLSL verzia

// vyroba normalmapy v gimpe:
// colors - desaturate
// definovat miesta s minimalnou a maximalnou vyskou
// toto je potrebne urobit manualne, neexistuje filter
// filters - map - normalmap - vsetko nechat standardne
// duplicate layer
// nova vrstva - gaussian blur
// nova vrstva - mode - grain merge
// vytvorit tolko novych vrstiev aby sme ziskali potrebny
// vyskovy rozdiel normalmapy

uniform sampler2D base_tex_unit; // zakladna textura
uniform sampler2D nm_tex_unit;   // normalmap textura

in vec4 pos; // poloha vrcholu v EYE space
in vec3 nor;
in vec2 uv;
in vec3 dir_to_light,dir_to_eye;
in vec3 tbn_dir_to_light;
in vec4 ambient,diffuse,specular;

void main()
{
 vec4 color,amb,dif=vec4(0.0);
 vec3 N,L;
 float NdotL;

 // farba z textury
 color=texture(base_tex_unit,uv);

 // ambient
 amb=color*ambient;

 // normalizacia interpolovanych udajov
 //N=normalize(nor);
 //L=normalize(dir_to_light);

 // normalizovana normala z normalmap textury
 N=normalize(texture(nm_tex_unit,uv).xyz*2.0-1.0);
 // normalizovany interpolovany vektor
 L=normalize(tbn_dir_to_light);
 // intenzita difuznej zlozky v zavislosti od polohy svetelneho zdroja
 NdotL=max(dot(N,L),0.0);
 // diffuse
 dif=color*diffuse*NdotL;

 // vysledna farba
 gl_FragColor=amb+dif;
}
